<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 Julian Fries <julian.fries.3000@googlemail.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'Google Maps for tt_news' for the 'jf_easymaps' extension.
 *
 * @author	Julian Fries <julian.fries.3000@googlemail.com>
 * @package	TYPO3
 * @subpackage	tx_jfeasymaps
 */
class tx_jfeasymaps_pi1 extends tslib_pibase {

     var $prefixId      = 'tx_jfeasymaps_pi1';		// Same as class name
	 var $scriptRelPath = 'pi1/class.tx_jfeasymaps_pi1.php';	// Path to this script relative to the extension dir.
	 var $extKey        = 'jf_easymaps';	// The extension key.
	
	 /**
	  * The main method of the PlugIn
	  *
	  * @param	string		$content: The PlugIn content
	  * @param	array		$conf: The PlugIn configuration
	  * @return	The content that is displayed on the website
	  */
	  
     function main($content) {
     
		  $this->pi_setPiVarDefaults();
		  $this->pi_loadLL();
	   	  $this->pi_initPIflexForm();
		  $this->pi_USER_INT_obj = 1;

       // variablen
          $api_key = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'apikey');
          $getParams = t3lib_div::_GET();
          $getnewsuid = intval($getParams['tx_ttnews']['tt_news'],'tt_news');
          
       // datenbank abfrage
	      $res=$GLOBALS['TYPO3_DB']->exec_SELECTquery(
          '*',   
          'tt_news', 
          'hidden=0 and deleted=0 and uid="'.$getnewsuid.'"', 
          $groupBy='',
          $orderBy='',
          $limit='1');
        
          if($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {

               $strasse = $row['tx_jfeasymaps_street'];
               $stadt = $row['tx_jfeasymaps_city'];
               $land = $row['tx_jfeasymaps_land'];
               $infotext = $row['tx_jfeasymaps_infofenster'];
               $map_height = $row['tx_jfeasymaps_height'];
               $type = $row['tx_jfeasymaps_type'];
        
          }

          if (($api_key !='') && ($strasse != '') && ($stadt != '')) {

               if (!$map_height) $height = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'height') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'height') : '200';               
               else { $height = $map_height; }

	           $width = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'width') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'width') : '400';
               $zoom = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'zoom') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'zoom') : '5';
               $infofenster = $infotext ? 'open' : 'close';
               $userdefimg = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'userdefimg') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'userdefimg') : '';
               $userdefimg2 = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'userdefimg2') ? $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'userdefimg2') : '';
               $activateuserdefimg = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'userdefimg') ? ', markerOptions' : '';
               
               switch($type) {
		       case '0':
			        $maptype = 'G_NORMAL_MAP';
				    break;
		       case '1':
			        $maptype = 'G_SATELLITE_MAP';
				    break;
		       case '2':
			        $maptype = 'G_HYBRID_MAP';
				    break;
			   default:
			        $maptype = 'G_NORMAL_MAP';
			 	    break;
			 	    
               }
               

               $javascript .= "

               <script src=\"http://maps.google.com/maps?file=api&amp;v=2&amp;key=".$api_key."\" type=\"text/javascript\"></script>

               <script type=\"text/javascript\">

               //<![CDATA[

               var map;

               var mapcoder;

               function load() {

               if(GBrowserIsCompatible()) {

               mapcoder = new GClientGeocoder();

               map = new GMap2(document.getElementById(\"map\"));

                mapcoder.getLatLng('\"".$strasse."\", \"".$stadt."\", \"".$land."\"',

               function(point) {

               if (!point) {

               } else {

               map.setCenter(point, ".$zoom.");

               }

               });

               addAddress('\"".$strasse."\" \"".$stadt."\"');

               }

               }

               function addAddress(address) {

               map.addControl(new GSmallMapControl()); 

               mapcoder.getLatLng(address,

               function(point) {

               if(point) {

               var altIcon = new GIcon(); 

               altIcon.image = '".$userdefimg."';
               altIcon.shadow = '".$userdefimg2."';
               altIcon.iconSize = new GSize(35, 35);
               altIcon.shadowSize = new GSize(60, 35);
               altIcon.iconAnchor = new GPoint(6, 20);
               altIcon.infoWindowAnchor = new GPoint(5, 1);
               markerOptions = { icon:altIcon };

               var marker = new GMarker(point".$activateuserdefimg.");

               map.setMapType(".$maptype.");

               map.addOverlay(marker);

               var html   = '".$infotext."';  

               GEvent.addListener(marker, \"click\", function() {marker.openInfoWindowHtml(html)}); 

               marker.".$infofenster."InfoWindowHtml('".$infotext."'); 

               }

               });

               }

               //]]>

               </script>

               <script language=\"javascript\" type=\"text/javascript\">

               window.onload = function () {load(); }

               </script>";           

            // now place the var $javascript into the header

               $GLOBALS['TSFE']->additionalHeaderData[$this->extKey] = $javascript;  
		       $content = '<div id="map" style="width: '.$width.'px; height: '.$height.'px; background-color:#d0d0d0;cursor:pointer"></div>';
               return $this->pi_wrapInBaseClass($content);

          } else {
          
            // in case user hasnt made any specifications according street and city or if the api-key in flexform is wrong, no content will be rendered
               $content = '';
               return $this->pi_wrapInBaseClass($content);

          }

     }

}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/jf_easymaps/pi1/class.tx_jfeasymaps_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/jf_easymaps/pi1/class.tx_jfeasymaps_pi1.php']);
}

?>